<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>ISocialAccountRequest</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/routes/auth/auth.controller.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                        <a href="#access_token">access_token</a>
                                </li>
                                <li>
                                        <a href="#device_id">device_id</a>
                                </li>
                                <li>
                                        <a href="#email">email</a>
                                </li>
                                <li>
                                        <a href="#notification_token">notification_token</a>
                                </li>
                                <li>
                                        <a href="#platform">platform</a>
                                </li>
                                <li>
                                        <a href="#social_access_token">social_access_token</a>
                                </li>
                                <li>
                                        <a href="#social_provider">social_provider</a>
                                </li>
                                <li>
                                        <a href="#user_id">user_id</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="access_token"></a>
                                        <span class="name"><b>access_token</b><a href="#access_token"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>access_token:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="device_id"></a>
                                        <span class="name"><b>device_id</b><a href="#device_id"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>device_id:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="email"></a>
                                        <span class="name"><b>email</b><a href="#email"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>email:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="notification_token"></a>
                                        <span class="name"><b>notification_token</b><a href="#notification_token"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>notification_token:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="platform"></a>
                                        <span class="name"><b>platform</b><a href="#platform"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>platform:         <code><a href="../miscellaneous/typealiases.html#DevicePlatforms" target="_self" >DevicePlatforms</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="../miscellaneous/typealiases.html#DevicePlatforms" target="_self" >DevicePlatforms</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="social_access_token"></a>
                                        <span class="name"><b>social_access_token</b><a href="#social_access_token"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>social_access_token:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="social_provider"></a>
                                        <span class="name"><b>social_provider</b><a href="#social_provider"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>social_provider:         <code><a href="../miscellaneous/enumerations.html#SocialProviders" target="_self" >SocialProviders</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="../miscellaneous/enumerations.html#SocialProviders" target="_self" >SocialProviders</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="user_id"></a>
                                        <span class="name"><b>user_id</b><a href="#user_id"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>user_id:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { createHmac } from &#x27;crypto&#x27;
import {
    Controller, Request, Post, UseGuards, Get, Logger, Body, BadRequestException
} from &#x27;@nestjs/common&#x27;
// import {
//     AuthService, LocalAuthGuard, UsersService
// } from &#x27;./../../services&#x27;
import { JwtAuthGuard } from &#x27;src/services/auth/jwt-auth.guard&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { Roles } from &#x27;src/services/auth/authorization/roles.decorator&#x27;
import { RolesGuard } from &#x27;src/services/auth/authorization/roles.guard&#x27;
import { SocialAccountGuard } from &#x27;src/services/auth/social/social-account.guard&#x27;
import { LocalAuthGuard } from &#x27;src/services/auth/local-auth.guard&#x27;
import { AuthService } from &#x27;src/services/auth/auth.service&#x27;
import { INotificationCredential, RoleTypes, IUserFireEntity } from &#x27;src/services/users/models&#x27;
import { UsersService } from &#x27;src/services/users/services/users.service&#x27;
import { DevicePlatforms } from &#x27;src/models/common/common&#x27;

enum Routes {
    LOGIN &#x3D; &#x27;auth/login&#x27;,
    SOCIAL_LOGIN &#x3D; &#x27;auth/social-login&#x27;,
    SOCIAL_ROLE_LOGIN &#x3D; &#x27;auth/social-role-login&#x27;,
    SOCIAL_ADMIN_LOGIN &#x3D; &#x27;auth/social-admin-login&#x27;,
    GET_FIREBASE_CONFIG &#x3D; &#x27;auth/firebase-config&#x27;,
    TWITCH_LOGIN &#x3D; &#x27;auth/twitch-login&#x27;,
    REGISTER &#x3D; &#x27;auth/register&#x27;,
    CHECK_AVAILABILITY &#x3D; &#x27;auth/check-name&#x27;,
    REGISTER_FROM_SOCIAL &#x3D; &#x27;auth/register-from-social&#x27;,
    GET_PROFILE &#x3D; &#x27;profile&#x27;,
}

interface INameCheck&lt;T extends string | boolean&gt; {
    username: T
}

interface ILoginRequest {
    username: string
    password: string
}

enum SocialProviders {
    FACEBOOK &#x3D; &#x27;facebook&#x27;,
}

interface ISocialAccountRequest {
    user_id: string
    email: string
    access_token: string
    social_access_token: string
    social_provider: SocialProviders
    // notification_credentials?: INotificationCredential
    device_id: string
    notification_token: string
    platform: DevicePlatforms
    // username: string
    // password: string
}

interface ISocialRegisterRequest {
    user_id: string
    email: string
    access_token: string
    username: string
    first_name: string
    last_name: string
    avatar: string
    avatar_url: string
    private_account: boolean
    use_real_name: boolean
    notification_credentials?: INotificationCredential
}

@Controller()
export class AuthController {
    private readonly logger &#x3D; new Logger(AuthController.name)
    private readonly key: string

    constructor(
        private readonly authService: AuthService,
        private readonly usersService: UsersService,
    ) {
        this.key &#x3D; process.env.ACCOUNT_KEY
    }

    // @UseGuards(LocalAuthGuard)
    // @Post(Routes.LOGIN)
    // async login(@Body() req_body: ILoginRequest) {

    //     this.logger.debug(&#x27;login&#x27;)
    //     const body &#x3D; {
    //         username: req_body.username,
    //         password: req_body.password,
    //     }
    //     return this.authService.login(body)
    // }

    @UseGuards(SocialAccountGuard)
    @Post(Routes.SOCIAL_LOGIN)
    async socialLogin(@Body() req_body: ISocialAccountRequest) {

        // const body &#x3D; {
        //     user_id: req_body.user_id,
        //     access_token: req_body.access_token,
        //     social_access_token: req_body.social_access_token,
        //     social_provider: req_body.social_provider,
        //     notification_credentials: req_body.notification_credentials ?? null,
        // }
        const {
            user_id,
            access_token,
            social_access_token,
            social_provider,
            // notification_credentials,
            device_id,
            notification_token,
            platform,
        } &#x3D; req_body
        return await this.authService.social_login(
            user_id,
            // access_token,
            // social_access_token,
            // social_provider,
            // notification_credentials.device_id,
            // notification_credentials.notification_token,
            // notification_credentials.platform,
            device_id,
            notification_token,
            platform,
        )
    }

    // @UseGuards(SocialAccountGuard, RolesGuard)
    // @Roles(RoleTypes.ADMIN)
    // @Post(Routes.SOCIAL_ROLE_LOGIN)
    // async socialRoleLogin(@Body() req_body: ISocialAccountRequest) {
    //     // const body &#x3D; {
    //     //     user_id: req_body.user_id,
    //     //     access_token: req_body.access_token,
    //     //     social_access_token: req_body.social_access_token,
    //     //     social_provider: req_body.social_provider,
    //     //     notification_credentials: req_body.notification_credentials ?? null,
    //     // }
    //     // return await this.authService.social_login(body)
    //     const {
    //         user_id,
    //         access_token,
    //         social_access_token,
    //         social_provider,
    //         notification_credentials,
    //     } &#x3D; req_body
    //     return await this.authService.social_login(
    //         user_id,
    //         // access_token,
    //         // social_access_token,
    //         // social_provider,
    //         notification_credentials.device_id,
    //         notification_credentials.notification_token,
    //         notification_credentials.platform,
    //     )
    // }

    async _registerFromSocial(body: ISocialRegisterRequest) {
        // const username &#x3D; new ObjectId().toHexString()
        const password &#x3D; new ObjectId().toHexString()
        const pw &#x3D;
            createHmac(&#x27;sha512&#x27;, this.key)
                .update(password)
                .digest(&#x27;hex&#x27;)

        const mongo_id &#x3D; new ObjectId()

        const { validation_passed, access_token } &#x3D;
            await this.usersService.createUserFromFirebase({
                fire_id: body.user_id,
                _id: mongo_id.toHexString(),
                username: body.username,
                password: pw,
                email: body.email,
                access_token: body.access_token,
                first_name: body.first_name,
                last_name: body.last_name,
                avatar: body.avatar,
                avatar_url: body.avatar_url,
                private_account: body.private_account,
                use_real_name: body.use_real_name,
            })

        return {
            validation_passed,
            username: body.username,
            password,
            access_token,
        }
    }

    @Post(&#x27;auth/check-account&#x27;)
    async checkAccount(
        @Body() body: ISocialAccountRequest
    ) {
        const { user_id, email, access_token } &#x3D; body
        const res: IUserFireEntity &#x3D;
            await this.usersService.findOne(&#x27;fire_id&#x27;, user_id)

        return res !&#x3D;&#x3D; null ? true : false
    }

    @Post(Routes.REGISTER_FROM_SOCIAL)
    async registerFromSocial(
        @Body() body: ISocialRegisterRequest
    ) {
        this.logger.debug(this.registerFromSocial.name)

        const {
            user_id,
            email,
            access_token,
            username,
            first_name,
            last_name,
            avatar,
            avatar_url,
            private_account,
            use_real_name,
        } &#x3D; body
        const res: IUserFireEntity &#x3D;
            await this.usersService.findOne(&#x27;fire_id&#x27;, user_id)

        if (res !&#x3D;&#x3D; null) {
            // const pw &#x3D;
            //     createHmac(&#x27;sha512&#x27;, this.key)
            //         .update(res.password)
            //         .digest(&#x27;hex&#x27;)

            return {
                validation_passed: true,
                _id: user_id,
                username: res.username,
                email: res.email,
                access_token
                // password: pw,
            }
        }

        let response &#x3D; await this._registerFromSocial({
            user_id,
            email,
            access_token,
            username,
            first_name,
            last_name,
            avatar,
            avatar_url,
            private_account,
            use_real_name,
        })

        if (!response.validation_passed) {
            return {
                validation_passed: false,
            }
        } else {
            return {
                validation_passed: true,
                _id: user_id,
                username: response.username,
                access_token: response.access_token,
                // password: response.password,
            }
        }
    }

    @Post(Routes.CHECK_AVAILABILITY)
    async checkNameAvailability(
        @Body() body: INameCheck&lt;string&gt;) {

        const { username } &#x3D; body

        const res: INameCheck&lt;boolean&gt; &#x3D;
            await this.usersService.checkIfNamesAreAvailable(username)

        return res
    }

    @UseGuards(JwtAuthGuard)
    @Get(Routes.GET_PROFILE)
    async getProfile(@Request() req) {
        return req.user
    }

    @UseGuards(SocialAccountGuard, RolesGuard)
    @Roles(RoleTypes.ADMIN)
    @Post(Routes.GET_FIREBASE_CONFIG)
    async getFirebaseConfig() {

        const array &#x3D; [
            process.env.FIREBASE_APIKEY,
            process.env.FIREBASE_AUTHDOMAIN,
            process.env.FIREBASE_DATABASE_URL,
            process.env.FIREBASE_PROJECT_ID,
            process.env.FIREBASE_STORAGE_BUCKET,
            process.env.FIREBASE_MESSAGING_SENDER_ID,
            process.env.FIREBASE_APP_ID,
            process.env.FIREBASE_MEASUREMENT_ID,
        ]

        if (array.some(s &#x3D;&gt;
            s &#x3D;&#x3D;&#x3D; undefined ||
            s.length &lt;&#x3D; 0)) {
            throw new BadRequestException({
                message: &#x27;Config values are invalid on server&#x27;
            },
                &#x27;Config values on server are invalid&#x27;
            )
        }

        const firebaseConfig &#x3D; {
            apiKey: process.env.FIREBASE_APIKEY,
            authDomain: process.env.FIREBASE_AUTHDOMAIN,
            databaseURL: process.env.FIREBASE_DATABASE_URL,
            projectId: process.env.FIREBASE_PROJECT_ID,
            storageBucket: process.env.FIREBASE_STORAGE_BUCKET,
            messagingSenderId: process.env.FIREBASE_MESSAGING_SENDER_ID,
            appId: process.env.FIREBASE_APP_ID,
            measurementId: process.env.FIREBASE_MEASUREMENT_ID,
        }

        return firebaseConfig
    }
}</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'ISocialAccountRequest.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
